package model;

import java.util.Map;

/**
 * This is the class which directly communicates with the database and fetches
 * the values to be used by the main algorithm.
 * 
 * @author michael.giambi
 *
 */

public interface QueryManager {

	/**
	 * Interrogates the DB with a SQL query. Each iteration of this method
	 * search for a single coordinate type. A complete search is made by six
	 * iterations (one per coordinate).
	 * 
	 * @param coordinate
	 *            the coordinate to look for.
	 * @param value
	 *            the coordinate value.
	 * @return A list of all graphs that match the chosen value and thier score.
	 */
	public Map<String, Float> SearchDB(final Integer coordinate, final String value);
	
	public void writeHistory(final Map<String, Integer> input);

}
