package parser;

import java.util.*;

import java.io.File;
import javax.xml.parsers.*;
import javax.xml.transform.*;
import javax.xml.transform.dom.*;
import javax.xml.transform.stream.*;

import org.w3c.dom.*;

import utilities.*;

public class XMLcreatorImpl implements XMLcreator {

	public XMLcreatorImpl() {
	}

	@Override
	public void createXML(final List<String> variables, final List<Integer> priorities) {

		try {

			/* Inizialization */
			DocumentBuilderFactory docFactory = DocumentBuilderFactory.newInstance();
			DocumentBuilder docBuilder = docFactory.newDocumentBuilder();
			TransformerFactory transformerFactory = TransformerFactory.newInstance();
			Transformer transformer = transformerFactory.newTransformer();
			int start = 0;
			int limit = 0;

			/* Create root node */
			Document doc = docBuilder.newDocument();
			Element rootElement = doc.createElement("BigDataPipelineArea");
			doc.appendChild(rootElement);

			/* Iteratively create elements and sets values and attributes */
			for (int i = 0; i < StaticVariables.FI_NUMBER; i++) {
				Element temp = doc.createElement(StaticVariables.FI_NAMES[i]);
				rootElement.appendChild(temp);
				temp.setAttribute(StaticVariables.PRIORITY_NAME,
						priorities.get(StaticVariables.COORDINATES_NUMBER + i).toString());

				if (i == StaticVariables.OPERATIVITY) {
					start = 0;
					limit = StaticVariables.OPERATIVITY_LIMIT;
				} else if (i == StaticVariables.DATA_MODELING) {
					start = StaticVariables.OPERATIVITY_LIMIT;
					limit = StaticVariables.COORDINATES_NUMBER;
				}

				for (int j = start; j < limit; j++) {
					final String tempVar = variables.get(j);

					if (!tempVar.contains("null")) {
						Element temp2 = doc.createElement(StaticVariables.COORDINATES_NAMES[j]);
						temp2.appendChild(doc.createTextNode(tempVar));
						temp.appendChild(temp2);
						temp2.setAttribute(StaticVariables.PRIORITY_NAME, priorities.get(j).toString());
					}
				}
			}

			/* Writes the content into file */
			transformer.transform(new DOMSource(doc), new StreamResult(new File(StaticVariables.XML_PATH)));

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
