package parser;

import java.io.File;
import java.util.*;
import javax.xml.parsers.*;
import org.w3c.dom.*;

import utilities.*;

public class XMLreaderImpl implements XMLreader {

	private final Map<String, Integer> result = new LinkedHashMap<>();

	public XMLreaderImpl() {
	};

	@Override
	public Map<String, Integer> readXML(String path) {

		try {

			/* Inizialization */
			File fXmlFile = new File(path);
			DocumentBuilderFactory dbFactory = DocumentBuilderFactory.newInstance();
			DocumentBuilder dBuilder = dbFactory.newDocumentBuilder();
			Document doc = dBuilder.parse(fXmlFile);
			doc.getDocumentElement().normalize();
			NodeList nList;
			Element element;

			for (int i = 0; i < StaticVariables.COORDINATES_NUMBER; i++) {
				nList = doc.getElementsByTagName(StaticVariables.COORDINATES_NAMES[i]);

				if (nList.getLength() > 0) {
					element = (Element) nList.item(0);

					result.put(element.getTextContent(),
							Integer.parseInt(element.getAttribute(StaticVariables.PRIORITY_NAME)));
				}
			}

			for (int i = 0; i < StaticVariables.FI_NUMBER; i++) {
				nList = doc.getElementsByTagName(StaticVariables.FI_NAMES[i]);

				if (nList.getLength() > 0) {
					element = (Element) nList.item(0);

					result.put(StaticVariables.FI_NAMES[i],
							Integer.parseInt(element.getAttribute(StaticVariables.PRIORITY_NAME)));
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}

		return result;
	}

}
