package utilities;

import java.util.Arrays;
import java.util.List;

public enum DataType {

	INTERVAL("Interval"), ORDINAL("Ordinal"), NOMINAL("Nominal"), RATIO("Ratio");

	private final String name;

	DataType(final String name) {
		this.name = name;
	}

	public String getName() {
		return name;
	}

	public static String[] getAllValues() {
		return new String[] { INTERVAL.name, ORDINAL.name, NOMINAL.name, RATIO.name };
	}

	public static List<String> getAllValuesAsList() {
		return Arrays.asList(getAllValues());
	}

}
