package utilities;

import java.util.Arrays;
import java.util.List;

public enum Goal {

	COMPOSITION("Composition"), GEOSPATIAL("Geospatial"), ORDER_RANK_SORT("Order/rank/sort"), RELATIONSHIP(
			"Relationship"), COMPARISON("Comparison"), CLUSTER_CATEGORIZE(
					"Cluster/Categorize"), DISTRIBUTION("Distribution"), TRENDS("Trends");

	private final String name;

	Goal(final String name) {
		this.name = name;
	}

	public String getName() {
		return name;
	}

	public static String[] getAllValues() {
		return new String[] { COMPOSITION.name, GEOSPATIAL.name, ORDER_RANK_SORT.name, RELATIONSHIP.name,
				COMPARISON.name, CLUSTER_CATEGORIZE.name, DISTRIBUTION.name, TRENDS.name };
	}

	public static List<String> getAllValuesAsList() {
		return Arrays.asList(getAllValues());
	}

}
