package utilities;

import java.util.Arrays;
import java.util.List;

public enum Interaction {

	FILTER("Filter"), ZOOM("Zoom"), OVERVIEW("Overview"), DETAILS_ON_DEMAND(
			"Details-on-demand"), EXTRACT("Extract"), PROJECTION("Projection"), HISTORY("History"), SEARCH_AND_LOCATE(
					"Search &amp; Locate"), DISTORTION("Distortion"), LINK_AND_BRUSH("Link &amp; Brush");

	private final String name;

	Interaction(final String name) {
		this.name = name;
	}

	public String getName() {
		return name;
	}

	public static String[] getAllValues() {
		return new String[] { FILTER.name, ZOOM.name, OVERVIEW.name, DETAILS_ON_DEMAND.name,
				EXTRACT.name, PROJECTION.name, HISTORY.name, SEARCH_AND_LOCATE.name, DISTORTION.name,
				LINK_AND_BRUSH.name };
	}

	public static List<String> getAllValuesAsList() {
		return Arrays.asList(getAllValues());
	}

}
