package view;

import java.awt.BorderLayout;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import java.awt.GridLayout;
import javax.swing.JLabel;
import javax.swing.border.TitledBorder;
import javax.swing.border.BevelBorder;
import javax.swing.UIManager;
import javax.swing.JCheckBox;
import javax.swing.JButton;
import javax.swing.JSlider;
import javax.swing.SwingConstants;
import java.awt.Dimension;

import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import javax.swing.JSeparator;
import javax.swing.JComboBox;
import javax.swing.JTable;
import javax.swing.ImageIcon;

import utilities.*;

public class GUIimpl2 extends JFrame implements GUI {

	/**
	 * 
	 */
	private static final long serialVersionUID = -7010737979451846780L;
	private JPanel mainPanel;
	private JTable resultTable;

	final JSlider operativityPrioritySlider = new JSlider();
	final JComboBox<String> goalComboBox = new JComboBox<>(Goal.getAllValues());
	final JCheckBox goalCheckBox = new JCheckBox("Goal");
	final JSlider goalSlider = new JSlider();
	final JCheckBox dimensionalityCheckBox = new JCheckBox("Dimensionality");
	final JComboBox<String> dimensionalityComboBox = new JComboBox<>(Dimensionality.getAllValues());
	final JSlider dimensionalitySlider = new JSlider();
	final JCheckBox dataDensityCheckBox = new JCheckBox("Cardinality");
	final JComboBox<String> dataDensityComboBox = new JComboBox<>(DataDensity.getAllValues());
	final JSlider dataDensitySlider = new JSlider();
	final JCheckBox interactionCheckBox = new JCheckBox("Interaction");
	final JComboBox<String> interactionComboBox = new JComboBox<>(Interaction.getAllValues());
	final JSlider interactionSlider = new JSlider();
	final JCheckBox dataTypeCheckBox = new JCheckBox("DataType");
	final JComboBox<String> dataTypeComboBox = new JComboBox<>(DataType.getAllValues());
	final JSlider dataTypeSlider = new JSlider();
	final JCheckBox userCheckBox = new JCheckBox("User");
	final JComboBox<String> userComboBox = new JComboBox<>(User.getAllValues());
	final JSlider userSlider = new JSlider();
	final JSlider dataModelingPrioritySlider = new JSlider();
	final JButton fileUploadButton = new JButton("Upload");
	final ImageIcon img = new ImageIcon("./matador-icon_34105.png");

	/**
	 * Create the frame.
	 */
	public GUIimpl2() {
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(300, 50, 900, 750);
		mainPanel = new JPanel();
		mainPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(mainPanel);
		mainPanel.setLayout(new GridLayout(0, 2, 0, 0));

		JPanel leftPanel = new JPanel();
		leftPanel.setBorder(new BevelBorder(BevelBorder.LOWERED, null, null, null, null));
		mainPanel.add(leftPanel);
		GridBagLayout gbl_leftPanel = new GridBagLayout();
		gbl_leftPanel.columnWidths = new int[] { 0, 0 };
		gbl_leftPanel.rowHeights = new int[] { 538, 105, 0 };
		gbl_leftPanel.columnWeights = new double[] { 1.0, Double.MIN_VALUE };
		gbl_leftPanel.rowWeights = new double[] { 1.0, 1.0, Double.MIN_VALUE };
		leftPanel.setLayout(gbl_leftPanel);

		JPanel userInputPanel = new JPanel();
		userInputPanel.setBorder(new TitledBorder(null, "Choose your preferences...", TitledBorder.CENTER,
				TitledBorder.TOP, null, null));
		GridBagConstraints gbc_userInputPanel = new GridBagConstraints();
		gbc_userInputPanel.weighty = 9.0;
		gbc_userInputPanel.insets = new Insets(0, 0, 5, 0);
		gbc_userInputPanel.fill = GridBagConstraints.BOTH;
		gbc_userInputPanel.gridx = 0;
		gbc_userInputPanel.gridy = 0;
		leftPanel.add(userInputPanel, gbc_userInputPanel);
		userInputPanel.setLayout(new GridLayout(2, 0, 0, 0));

		JPanel operativityPanel = new JPanel();
		operativityPanel
				.setBorder(new TitledBorder(null, "Operativity", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		userInputPanel.add(operativityPanel);
		GridBagLayout gbl_operativityPanel = new GridBagLayout();
		gbl_operativityPanel.columnWidths = new int[] { 279, 0 };
		gbl_operativityPanel.rowHeights = new int[] { 62, 122, 0 };
		gbl_operativityPanel.columnWeights = new double[] { 1.0, Double.MIN_VALUE };
		gbl_operativityPanel.rowWeights = new double[] { 1.0, 1.0, Double.MIN_VALUE };
		operativityPanel.setLayout(gbl_operativityPanel);

		JPanel operativityPriorityPanel = new JPanel();
		operativityPriorityPanel
				.setBorder(new TitledBorder(null, "", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		GridBagConstraints gbc_operativityPriorityPanel = new GridBagConstraints();
		gbc_operativityPriorityPanel.insets = new Insets(0, 0, 5, 0);
		gbc_operativityPriorityPanel.fill = GridBagConstraints.BOTH;
		gbc_operativityPriorityPanel.gridx = 0;
		gbc_operativityPriorityPanel.gridy = 0;
		operativityPanel.add(operativityPriorityPanel, gbc_operativityPriorityPanel);
		operativityPriorityPanel.setLayout(new GridLayout(0, 2, 0, 0));

		JLabel operativityPriorityLabel = new JLabel("Operativity Priority");
		operativityPriorityLabel.setToolTipText(
				"This Functional Goal groups all the Functional Indicators related to the operativity for analyzing data");
		operativityPriorityLabel.setHorizontalAlignment(SwingConstants.CENTER);
		operativityPriorityPanel.add(operativityPriorityLabel);

		operativityPrioritySlider.setPaintLabels(true);
		operativityPrioritySlider.setSnapToTicks(true);
		operativityPrioritySlider.setMajorTickSpacing(1);
		operativityPrioritySlider.setMinorTickSpacing(1);
		operativityPrioritySlider.setPaintTicks(true);
		operativityPrioritySlider.setMaximum(6);
		operativityPrioritySlider.setMinimum(1);
		operativityPrioritySlider.setValue(1);
		operativityPriorityPanel.add(operativityPrioritySlider);

		operativityPanel.add(new JSeparator(JSeparator.HORIZONTAL));

		JPanel operativityCoordinatesPanel = new JPanel();
		GridBagConstraints gbc_operativityCoordinatesPanel = new GridBagConstraints();
		gbc_operativityCoordinatesPanel.fill = GridBagConstraints.BOTH;
		gbc_operativityCoordinatesPanel.gridx = 0;
		gbc_operativityCoordinatesPanel.gridy = 1;
		operativityPanel.add(operativityCoordinatesPanel, gbc_operativityCoordinatesPanel);
		operativityCoordinatesPanel.setLayout(new GridLayout(4, 3, 0, 0));

		JLabel operativityCoordinateLabel = new JLabel("Functional Indicator");
		operativityCoordinateLabel.setHorizontalAlignment(SwingConstants.CENTER);
		operativityCoordinatesPanel.add(operativityCoordinateLabel);

		JLabel operativityValueLabel = new JLabel("Functional Objective");
		operativityValueLabel.setHorizontalAlignment(SwingConstants.CENTER);
		operativityCoordinatesPanel.add(operativityValueLabel);

		JLabel operativityPriority2Label = new JLabel("Priority");
		operativityPriority2Label.setHorizontalAlignment(SwingConstants.CENTER);
		operativityCoordinatesPanel.add(operativityPriority2Label);

		interactionCheckBox
				.setToolTipText("This coordinate is used to enable TOREADOR users to declare the type of interactions"
						+ " to be supported by the visualization");
		operativityCoordinatesPanel.add(interactionCheckBox);

		interactionComboBox.setEnabled(false);
		operativityCoordinatesPanel.add(interactionComboBox);

		interactionSlider.setEnabled(false);
		interactionSlider.setPaintLabels(true);
		interactionSlider.setMajorTickSpacing(1);
		interactionSlider.setPaintTicks(true);
		interactionSlider.setValue(1);
		interactionSlider.setMinorTickSpacing(1);
		interactionSlider.setMinimum(1);
		interactionSlider.setMaximum(6);
		operativityCoordinatesPanel.add(interactionSlider);

		goalCheckBox.setToolTipText("This coordinate is used to enable TOREADOR users to declare their analysis goal");
		operativityCoordinatesPanel.add(goalCheckBox);

		goalComboBox.setEnabled(false);
		operativityCoordinatesPanel.add(goalComboBox);

		goalSlider.setEnabled(false);
		goalSlider.setMajorTickSpacing(1);
		goalSlider.setPaintLabels(true);
		goalSlider.setValue(1);
		goalSlider.setSnapToTicks(true);
		goalSlider.setPaintTicks(true);
		goalSlider.setMaximum(6);
		goalSlider.setMinimum(1);
		goalSlider.setMinorTickSpacing(1);
		operativityCoordinatesPanel.add(goalSlider);

		userCheckBox.setToolTipText("This coordinate is used to enable TOREADOR users to declare their skill");
		operativityCoordinatesPanel.add(userCheckBox);

		userComboBox.setEnabled(false);
		operativityCoordinatesPanel.add(userComboBox);

		userSlider.setEnabled(false);
		userSlider.setPaintLabels(true);
		userSlider.setMajorTickSpacing(1);
		userSlider.setValue(1);
		userSlider.setPaintTicks(true);
		userSlider.setMinorTickSpacing(1);
		userSlider.setMinimum(1);
		userSlider.setMaximum(6);
		operativityCoordinatesPanel.add(userSlider);

		JPanel dataModelingPanel = new JPanel();
		dataModelingPanel.setBorder(new TitledBorder(UIManager.getBorder("TitledBorder.border"), "DataModeling",
				TitledBorder.LEADING, TitledBorder.TOP, null, null));
		userInputPanel.add(dataModelingPanel);
		GridBagLayout gbl_dataModelingPanel = new GridBagLayout();
		gbl_dataModelingPanel.columnWidths = new int[] { 0, 0 };
		gbl_dataModelingPanel.rowHeights = new int[] { 67, 140, 0 };
		gbl_dataModelingPanel.columnWeights = new double[] { 1.0, Double.MIN_VALUE };
		gbl_dataModelingPanel.rowWeights = new double[] { 1.0, 1.0, Double.MIN_VALUE };
		GridBagConstraints gbc_dataModelingPanel = new GridBagConstraints();
		gbc_dataModelingPanel.fill = GridBagConstraints.HORIZONTAL;
		gbc_dataModelingPanel.weightx = 1;
		dataModelingPanel.setLayout(gbl_dataModelingPanel);

		JPanel dataModelingPriorityPanel = new JPanel();
		dataModelingPriorityPanel
				.setBorder(new TitledBorder(null, "", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		GridBagConstraints gbc_dataModelingPriorityPanel = new GridBagConstraints();
		gbc_dataModelingPriorityPanel.insets = new Insets(0, 0, 5, 0);
		gbc_dataModelingPriorityPanel.fill = GridBagConstraints.BOTH;
		gbc_dataModelingPriorityPanel.gridx = 0;
		gbc_dataModelingPriorityPanel.gridy = 0;
		dataModelingPanel.add(dataModelingPriorityPanel, gbc_dataModelingPriorityPanel);
		dataModelingPriorityPanel.setLayout(new GridLayout(0, 2, 0, 0));

		JLabel dataModelingPriorityLabel = new JLabel("DataModeling Priority");
		dataModelingPriorityLabel.setToolTipText(
				"This Functional Goal groups all the Functional Indicators related to the structure of data to be visualized");
		dataModelingPriorityLabel.setHorizontalAlignment(SwingConstants.CENTER);
		dataModelingPriorityPanel.add(dataModelingPriorityLabel);

		dataModelingPrioritySlider.setPaintLabels(true);
		dataModelingPrioritySlider.setValue(1);
		dataModelingPrioritySlider.setPaintTicks(true);
		dataModelingPrioritySlider.setMinorTickSpacing(1);
		dataModelingPrioritySlider.setMinimum(1);
		dataModelingPrioritySlider.setMaximum(6);
		dataModelingPrioritySlider.setMajorTickSpacing(1);
		dataModelingPriorityPanel.add(dataModelingPrioritySlider);

		JSeparator dataModelingSeparator = new JSeparator(SwingConstants.HORIZONTAL);
		dataModelingSeparator.setPreferredSize(new Dimension(5, 5));
		dataModelingPanel.add(dataModelingSeparator);

		JPanel dataModelingCoordinatesPanel = new JPanel();
		GridBagConstraints gbc_dataModelingCoordinatesPanel = new GridBagConstraints();
		gbc_dataModelingCoordinatesPanel.fill = GridBagConstraints.BOTH;
		gbc_dataModelingCoordinatesPanel.gridx = 0;
		gbc_dataModelingCoordinatesPanel.gridy = 1;
		dataModelingPanel.add(dataModelingCoordinatesPanel, gbc_dataModelingCoordinatesPanel);
		dataModelingCoordinatesPanel.setLayout(new GridLayout(4, 3, 0, 0));

		JLabel dataModelingCoordinateLabel = new JLabel("Functional Indicator");
		dataModelingCoordinateLabel.setHorizontalAlignment(SwingConstants.CENTER);
		dataModelingCoordinatesPanel.add(dataModelingCoordinateLabel);

		JLabel dataModelingValueLabel = new JLabel("Functional Objective");
		dataModelingValueLabel.setHorizontalAlignment(SwingConstants.CENTER);
		dataModelingCoordinatesPanel.add(dataModelingValueLabel);

		JLabel dataModelingPriority2Label = new JLabel("Priority");
		dataModelingPriority2Label.setHorizontalAlignment(SwingConstants.CENTER);
		dataModelingCoordinatesPanel.add(dataModelingPriority2Label);

		dimensionalityCheckBox
				.setToolTipText("This coordinate is used to enable TOREADOR users to declare the number of"
						+ " variables they wish to visualize");
		dataModelingCoordinatesPanel.add(dimensionalityCheckBox);

		dimensionalityComboBox.setEnabled(false);
		dataModelingCoordinatesPanel.add(dimensionalityComboBox);

		dimensionalitySlider.setEnabled(false);
		dimensionalitySlider.setMajorTickSpacing(1);
		dimensionalitySlider.setPaintLabels(true);
		dimensionalitySlider.setValue(1);
		dimensionalitySlider.setSnapToTicks(true);
		dimensionalitySlider.setPaintTicks(true);
		dimensionalitySlider.setMinorTickSpacing(1);
		dimensionalitySlider.setMinimum(1);
		dimensionalitySlider.setMaximum(6);
		dataModelingCoordinatesPanel.add(dimensionalitySlider);

		dataDensityCheckBox
				.setToolTipText("This coordinate is used to enable TOREADOR users to qualitatively declare the"
						+ " cardinality of the data to be visualized");
		dataModelingCoordinatesPanel.add(dataDensityCheckBox);

		dataDensityComboBox.setEnabled(false);
		dataModelingCoordinatesPanel.add(dataDensityComboBox);

		dataDensitySlider.setEnabled(false);
		dataDensitySlider.setMajorTickSpacing(1);
		dataDensitySlider.setPaintLabels(true);
		dataDensitySlider.setValue(1);
		dataDensitySlider.setPaintTicks(true);
		dataDensitySlider.setMinorTickSpacing(1);
		dataDensitySlider.setMinimum(1);
		dataDensitySlider.setMaximum(6);
		dataModelingCoordinatesPanel.add(dataDensitySlider);

		dataDensityCheckBox
				.setToolTipText("This coordinate is used to enable TOREADOR users to qualitatively declare the"
						+ " cardinality of the data to be visualized");
		dataModelingCoordinatesPanel.add(dataTypeCheckBox);

		dataTypeCheckBox.setToolTipText("This coordinate is used to enable TOREADOR users to declare the type of each"
				+ " variable to be analyzed");
		dataTypeComboBox.setEnabled(false);
		dataModelingCoordinatesPanel.add(dataTypeComboBox);

		dataTypeSlider.setEnabled(false);
		dataTypeSlider.setPaintLabels(true);
		dataTypeSlider.setMajorTickSpacing(1);
		dataTypeSlider.setValue(1);
		dataTypeSlider.setPaintTicks(true);
		dataTypeSlider.setMinorTickSpacing(1);
		dataTypeSlider.setMinimum(1);
		dataTypeSlider.setMaximum(6);
		dataModelingCoordinatesPanel.add(dataTypeSlider);

		JPanel fileInputPanel = new JPanel();
		fileInputPanel.setBorder(new TitledBorder(UIManager.getBorder("TitledBorder.border"),
				"... or upload an existing XML file", TitledBorder.CENTER, TitledBorder.TOP, null, null));
		GridBagConstraints gbc_fileInputPanel = new GridBagConstraints();
		gbc_fileInputPanel.fill = GridBagConstraints.BOTH;
		gbc_fileInputPanel.gridx = 0;
		gbc_fileInputPanel.gridy = 1;
		leftPanel.add(fileInputPanel, gbc_fileInputPanel);
		fileInputPanel.setLayout(new GridLayout(1, 0, 0, 0));

		JPanel fileUploadPanel = new JPanel();
		fileInputPanel.add(fileUploadPanel);
		GridBagLayout gbl_fileUploadPanel = new GridBagLayout();
		gbl_fileUploadPanel.columnWidths = new int[] { 0, 0 };
		gbl_fileUploadPanel.rowHeights = new int[] { 0, 0 };
		gbl_fileUploadPanel.columnWeights = new double[] { 1.0, Double.MIN_VALUE };
		gbl_fileUploadPanel.rowWeights = new double[] { 1.0, Double.MIN_VALUE };
		fileUploadPanel.setLayout(gbl_fileUploadPanel);

		GridBagConstraints gbc_fileUploadButton = new GridBagConstraints();
		gbc_fileUploadButton.gridx = 0;
		gbc_fileUploadButton.gridy = 0;
		fileUploadPanel.add(fileUploadButton, gbc_fileUploadButton);

		JPanel rightPanel = new JPanel();
		rightPanel.setBorder(new BevelBorder(BevelBorder.LOWERED, null, null, null, null));
		mainPanel.add(rightPanel);
		rightPanel.setLayout(new BorderLayout(0, 0));

		JPanel resultPanel = new JPanel();
		resultPanel.setBorder(new TitledBorder(null, "Results", TitledBorder.CENTER, TitledBorder.TOP, null, null));
		rightPanel.add(resultPanel);
		resultPanel.setLayout(new BorderLayout(0, 0));

		resultTable = new JTable(new MyTableModel());

		for (int i = 0; i < StaticVariables.TABLE_ROWS; i++) {
			for (int j = 0; j < StaticVariables.TABLE_COLUMNS; j++) {
				resultTable.getModel().setValueAt("-", i, j);
			}
		}

		resultTable.setColumnSelectionAllowed(true);
		resultTable.setCellSelectionEnabled(true);
		resultPanel.add(resultTable, BorderLayout.CENTER);
		resultPanel.add(resultTable.getTableHeader(), BorderLayout.NORTH);

		this.setIconImage(img.getImage());
		this.setTitle("Toreador");
		setVisible(true);

		goalCheckBox.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {

				if (goalCheckBox.isSelected()) {
					goalComboBox.setEnabled(true);
					goalSlider.setEnabled(true);
				} else {
					goalComboBox.setEnabled(false);
					goalSlider.setEnabled(false);
				}

			}
		});

		dataDensityCheckBox.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {

				if (dataDensityCheckBox.isSelected()) {
					dataDensityComboBox.setEnabled(true);
					dataDensitySlider.setEnabled(true);
				} else {
					dataDensityComboBox.setEnabled(false);
					dataDensitySlider.setEnabled(false);
				}

			}
		});

		dimensionalityCheckBox.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {

				if (dimensionalityCheckBox.isSelected()) {
					dimensionalityComboBox.setEnabled(true);
					dimensionalitySlider.setEnabled(true);
				} else {
					dimensionalityComboBox.setEnabled(false);
					dimensionalitySlider.setEnabled(false);
				}

			}
		});

		interactionCheckBox.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {

				if (interactionCheckBox.isSelected()) {
					interactionComboBox.setEnabled(true);
					interactionSlider.setEnabled(true);
				} else {
					interactionComboBox.setEnabled(false);
					interactionSlider.setEnabled(false);
				}

			}
		});

		dataTypeCheckBox.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {

				if (dataTypeCheckBox.isSelected()) {
					dataTypeComboBox.setEnabled(true);
					dataTypeSlider.setEnabled(true);
				} else {
					dataTypeComboBox.setEnabled(false);
					dataTypeSlider.setEnabled(false);
				}

			}
		});

		userCheckBox.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {

				if (userCheckBox.isSelected()) {
					userComboBox.setEnabled(true);
					userSlider.setEnabled(true);
				} else {
					userComboBox.setEnabled(false);
					userSlider.setEnabled(false);
				}

			}
		});
	}

	@Override
	public List<JCheckBox> getCheckBoxes() {
		List<JCheckBox> temp = new ArrayList<>();

		temp.add(interactionCheckBox);
		temp.add(goalCheckBox);
		temp.add(userCheckBox);
		temp.add(dimensionalityCheckBox);
		temp.add(dataDensityCheckBox);
		temp.add(dataTypeCheckBox);

		return temp;
	}

	@Override
	public List<JComboBox<String>> getCoordinatesInput() {
		List<JComboBox<String>> temp = new ArrayList<>();

		temp.add(interactionComboBox);
		temp.add(goalComboBox);
		temp.add(userComboBox);
		temp.add(dimensionalityComboBox);
		temp.add(dataDensityComboBox);
		temp.add(dataTypeComboBox);

		return temp;
	}

	@Override
	public List<JSlider> getPrioritiesInput() {
		List<JSlider> temp = new ArrayList<>();

		temp.add(interactionSlider);
		temp.add(goalSlider);
		temp.add(userSlider);
		temp.add(dimensionalitySlider);
		temp.add(dataDensitySlider);
		temp.add(dataTypeSlider);

		return temp;
	}

	@Override
	public List<JSlider> getFGinput() {
		List<JSlider> temp = new ArrayList<>();

		temp.add(operativityPrioritySlider);
		temp.add(dataModelingPrioritySlider);

		return temp;
	}

	@Override
	public JButton getImportButton() {
		return fileUploadButton;
	}

	@Override
	public Map<String, Integer> getSelectedItems() {
		final Map<String, Integer> temp = new LinkedHashMap<>();

		if (interactionCheckBox.isSelected()) {
			temp.put((String) interactionComboBox.getSelectedItem(), interactionSlider.getValue());
		} else {
			temp.put("null_0", 0);
		}
		if (goalCheckBox.isSelected()) {
			temp.put((String) goalComboBox.getSelectedItem(), goalSlider.getValue());
		} else {
			temp.put("null_1", 0);
		}
		if (userCheckBox.isSelected()) {
			temp.put((String) userComboBox.getSelectedItem(), userSlider.getValue());
		} else {
			temp.put("null_2", 0);
		}
		if (dimensionalityCheckBox.isSelected()) {
			temp.put((String) dimensionalityComboBox.getSelectedItem(), dimensionalitySlider.getValue());
		} else {
			temp.put("null_3", 0);
		}
		if (dataDensityCheckBox.isSelected()) {
			temp.put((String) dataDensityComboBox.getSelectedItem(), dataDensitySlider.getValue());
		} else {
			temp.put("null_4", 0);
		}
		if (dataTypeCheckBox.isSelected()) {
			temp.put((String) dataTypeComboBox.getSelectedItem(), dataTypeSlider.getValue());
		} else {
			temp.put("null_5", 0);
		}

		temp.put("Operativity", operativityPrioritySlider.getValue());
		temp.put("DataModeling", dataModelingPrioritySlider.getValue());

		return temp;
	}

	@Override
	public void visualizeResults(Map<String, Float> results) {

		final List<String> graphs = new ArrayList<>();
		final List<String> graphNames = new ArrayList<>();
		final List<String> graphTypes = new ArrayList<>();
		final List<Float> graphScores = new ArrayList<>();
		int limit = 0;

		for (Map.Entry<String, Float> entry : results.entrySet()) {
			graphs.add(entry.getKey());
			graphScores.add(entry.getValue());
		}

		for (String s : graphs) {
			String[] temp = s.split("-");
			graphNames.add(temp[0]);
			graphTypes.add(temp[1]);
		}

		limit = graphNames.size();

		if (limit > StaticVariables.nResults) {
			limit = StaticVariables.nResults;
		}

		for (int i = 0; i < limit; i++) {
			resultTable.getModel().setValueAt(graphNames.get(i), i, 0);
			resultTable.getModel().setValueAt(graphTypes.get(i), i, 1);

			if (graphScores.get(i) < 0) {
				resultTable.getModel().setValueAt("Unfit", i, 2);
			} else {
				resultTable.getModel().setValueAt(graphScores.get(i).toString(), i, 2);
			}
		}

		if (limit < StaticVariables.nResults) {

			for (int i = limit; i < StaticVariables.nResults; i++) {
				resultTable.getModel().setValueAt("-", i, 0);
				resultTable.getModel().setValueAt("-", i, 1);
				resultTable.getModel().setValueAt("-", i, 2);
			}

		}

		resultTable.repaint();

	}

}
